package ejb31.war.servlet;

import javax.annotation.PostConstruct;
import javax.ejb.DependsOn;
import javax.ejb.EJB;
import javax.ejb.Singleton;
import javax.ejb.Startup;


@Singleton
@Startup
@DependsOn({"BeanLeaf"})
public class BeanRoot {

    @EJB
    private BeanLeaf bl;

    @EJB
    private BeanMessage msg;
    
    @PostConstruct
    public void afterConstruct() {
        System.out.println("------------------------------------");
        System.out.println("-----PostConstruct in BeanRoot------");
        System.out.println("------------------------------------");
        msg.appendMessage("PostBeanRoot");
        System.out.println("---access BeanLeaf in BeanRoot PostConstruct---");
        System.out.println("** Hello from beanLeaf: " + bl.sayHello());

    }
    
    public String sayHello() {
        return "Hello from: " + this.getClass().getName() + "; " + System.identityHashCode(this);
    }
    
}
