package ejb31.war.servlet;

import java.io.*;
import java.net.*;

import javax.ejb.EJB;
import javax.naming.*;

import javax.servlet.*;
import javax.servlet.http.*;


public class TestServlet extends HttpServlet {
   
    @EJB
    private BeanRoot root;

    @EJB
    private BeanMessage msg;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter out = response.getWriter();
        String result = "";

        try {
	    // 0. initial check
            out.println("TestServlet");  
            out.println("contextPath=" + request.getContextPath ());

            // 1. deployment check
            // result = msg.getMessage();
            // out.println("1. result=" + result);

            // 2. injection check
            out.println("2. injected root: " + root);
            // out.println("2. Hello from injected root: " + root.sayHello());
            
            // 3. lookup check
            InitialContext ic = new InitialContext();
            // "java"glabal/env/<appName>/<beanName>" for appName.war
            BeanRoot root2 = (BeanRoot) ic.lookup("java:global/env/warSingletonStartup/BeanRoot");
            out.println("3. global root: " + root2);
            // out.println("3. Hello from global root: " + root2.sayHello());

            // 4. final  check
            // result = msg.getMessage();
            // out.println("4. result=" + result);

        } catch (Throwable th) {
            th.printStackTrace(out);
        } finally { 
            out.close();
        }
    } 

    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
